function [QQnew, xxnew] = kalman_update(AA, ll, Ql, QQ, xx) 
  nPar = rows(xx);

  HH    = Ql + AA * QQ * AA';
  Hi    = inv(HH);
  KK    = QQ * AA' * Hi;
  vv    = ll - AA * xx;
  xxnew = xx + KK * vv;
  QQnew = (eye(nPar) - KK * AA) * QQ;
end

